﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;

namespace UltraChartLineChartWithVerticalLines
{
    public partial class Form1 : Form
    {
        private List<MyLineObject> MyList;

        public Form1()
        {
            InitializeComponent();
            MyList = new List<MyLineObject>();

            DataTable dt = new DataTable();
            dt.Columns.Add("Label", typeof(string));
            dt.Columns.Add("Line 1", typeof(decimal));
            dt.Columns.Add("Line 2", typeof(decimal));

            dt.Rows.Add("Point 1", 300, 450);
            dt.Rows.Add("Point 2", 310, 470);
            dt.Rows.Add("Point 3", 320, 430);
            dt.Rows.Add("Point 4", 310, 440);
            dt.Rows.Add("Point 5", 330, 480);
            dt.Rows.Add("Point 6", 320, 530);
            dt.Rows.Add("Point 7", 200, 450);
            dt.Rows.Add("Point 8", 210, 370);
            dt.Rows.Add("Point 9", 120, 230);
            dt.Rows.Add("Point 10", 310, 440);
            dt.Rows.Add("Point 11", 430, 480);
            dt.Rows.Add("Point 12", 420, 530);
            dt.Rows.Add("Point 13", 350, 430);
            dt.Rows.Add("Point 14", 380, 430);
            dt.Rows.Add("Point 15", 390, 410);

            
            
            ultraChart1.DataSource = dt;
        }
        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            if (MyList != null) MyList.Clear();
            foreach (Primitive pr in e.SceneGraph)
            {
                if (pr.GetType() == typeof(Polyline) && pr.Row == 0 && pr.Column == 0)
                {
                    foreach (DataPoint dp in ((Polyline)pr).points)
                    {
                        MyLineObject mlo = new MyLineObject();
                        mlo.Line1 = dp.point;
                        MyList.Add(mlo);
                    }
                }
                if (pr.GetType() == typeof(Polyline) && pr.Row == 1 && pr.Column == 1)
                {
                    int i = 0;
                    foreach (DataPoint dp in ((Polyline)pr).points)
                    {
                        MyList[i].Line2 = dp.point;
                        i++;
                    }
                }
            }


            if (MyList != null)
            {
                foreach (MyLineObject dp in MyList)
                {

                    Infragistics.UltraChart.Shared.Styles.LineStyle ls = new Infragistics.UltraChart.Shared.Styles.LineStyle();
                    ls.StartStyle = Infragistics.UltraChart.Shared.Styles.LineCapStyle.DiamondAnchor;
                    ls.EndStyle = Infragistics.UltraChart.Shared.Styles.LineCapStyle.DiamondAnchor;
                    ls.DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle.Dot;
                    Line ln = new Line(dp.Line1, dp.Line2, ls);
                    ln.drawColor = Color.Red;
                    e.SceneGraph.Add(ln);
                }
            }
        }
    }

    public class MyLineObject
    {

        private Point line1;

        public Point Line1
        {
            get { return line1; }
            set { line1 = value; }
        }

        private Point line2;

        public Point Line2
        {
            get { return line2; }
            set { line2 = value; }
        }
    }

}
